/// <reference types="node" />
/// <reference types="rascal" />
import { Consumer } from "./lib/consumer";
export declare class BrokerProxy {
    static create(config: any, components?: any): Promise<BrokerProxy>;
    private static instance;
    private config;
    private components;
    private broker;
    private publications;
    private subScriptions;
    private constructor();
    connect(name: string): Promise<any>;
    nuke(): Promise<void>;
    purge(): Promise<void>;
    shutdown(): Promise<void>;
    bounce(): Promise<void>;
    /**
     * publish message
     * @param name publication name
     * @param message message
     * @param overrides overrides
     */
    publish(name: string, message: any, overrides?: any): Promise<import("events").EventEmitter>;
    /**
     * direct subscribe use rascal
     * @param name subscription name
     * @param overrides overrides options
     */
    subscribe(name: string, overrides?: any): Promise<import("rascal").SubscriptionSession>;
    /**
     * add Consumer instance to receive message
     * @param consumer subclass of Consumer
     */
    addConsumer(consumer: Consumer): Promise<import("rascal").SubscriptionSession>;
    private getPublication;
    private getSubScription;
    private init;
    private attachBrokerHandlers;
    private onBrokerError;
    private onBrokerConnect;
    private onBrokerDisconnect;
    private runAllTimer;
    private stopAllTimer;
}
//# sourceMappingURL=broker.d.ts.map