import { Message } from "amqplib";
import { BrokerAsPromisedClass, SubscriptionSession, AckOrNackFn } from "rascal";
import { Consumer } from "./lib/consumer";
export default class SubScription {
    readonly consumer: Consumer;
    private session;
    private readonly broker;
    constructor(consumer: Consumer, broker: BrokerAsPromisedClass);
    subscribe(): Promise<SubscriptionSession>;
    messageHandler(message: Message, content: any, ackOrNack: AckOrNackFn): Promise<void>;
    onInvalidContent(err: Error, message: Message, ackOrNack: AckOrNackFn): Promise<void>;
    onRedeliveriesError(err: Error, message: Message, ackOrNack: AckOrNackFn): Promise<void>;
    onRedeliveriesExceeded(err: Error, message: Message, ackOrNack: AckOrNackFn): Promise<void>;
    onError(err: Error): Promise<void>;
    onConsumerCancel(err: Error): Promise<void>;
    private getRecovery;
    private attachSessionHandlers;
}
//# sourceMappingURL=subscription.d.ts.map